function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { Fragment, useEffect, useState } from 'react';
import { I18nProvider } from '@lingui/react';
import { Router } from 'react-router';
import { ThemeProvider } from '@tecsinapse/ui-kit';
import { ApolloProvider } from 'react-apollo';
import { provideI18nLanguageContext } from './i18n/provideI18nLanguageContext';
import { i18n } from './i18n/i18n';
import { appHistory } from './router/history';
export var ChildProviders = function ChildProviders(_ref) {
  var children = _ref.children,
      _ref$catalogs = _ref.catalogs,
      catalogs = _ref$catalogs === void 0 ? {} : _ref$catalogs,
      _ref$themeVariant = _ref.themeVariant,
      themeVariant = _ref$themeVariant === void 0 ? 'orange' : _ref$themeVariant,
      _ref$language = _ref.language,
      language = _ref$language === void 0 ? null : _ref$language;

  var _useState = useState('pt-br'),
      _useState2 = _slicedToArray(_useState, 2),
      locale = _useState2[0],
      setLocale = _useState2[1];

  useEffect(function () {
    if (language !== null) {
      loadCatalog(language);
    }
  }, [language]);
  var I18nBoilerplateProvider = provideI18nLanguageContext({
    locale: locale,
    setLocale: function setLocale(a) {
      return loadCatalog(a);
    }
  })(Fragment);

  var loadCatalog =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(newLanguage) {
      var catalog;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return typeof catalogs[newLanguage] === 'function' ? catalogs[newLanguage]() : catalogs[newLanguage];

            case 2:
              catalog = _context.sent;
              i18n.load(_defineProperty({}, newLanguage, catalog));
              i18n.activate(newLanguage);
              setLocale(newLanguage);

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function loadCatalog(_x) {
      return _ref2.apply(this, arguments);
    };
  }();

  return React.createElement(I18nBoilerplateProvider, null, React.createElement(I18nProvider, {
    language: locale,
    i18n: i18n
  }, React.createElement(ThemeProvider, {
    variant: themeVariant
  }, React.createElement(Router, {
    history: appHistory
  }, children))));
};