import React, { Fragment } from 'react';
import { Provider } from 'react-redux';
import { ApolloProvider } from 'react-apollo';
import { provideKeycloakContext } from './keycloak/provideKeycloakContext';
export var CoreProviders = function CoreProviders(_ref) {
  var keycloak = _ref.keycloak,
      client = _ref.client,
      store = _ref.store,
      children = _ref.children;
  var ReduxProvider = store == null ? Fragment : Provider;
  var KeycloakProvider = provideKeycloakContext(keycloak)(Fragment);
  return React.createElement(ReduxProvider, store == null ? {} : {
    store: store
  }, React.createElement(ApolloProvider, {
    client: client
  }, React.createElement(KeycloakProvider, null, children)));
};