import { Logger } from '../logger/logUtils';
export var mutationsErrorsHandler = function mutationsErrorsHandler(_ref) {
  var showSnackbar = _ref.showSnackbar,
      _ref$hideLoadingFunct = _ref.hideLoadingFunction,
      hideLoadingFunction = _ref$hideLoadingFunct === void 0 ? null : _ref$hideLoadingFunct,
      _ref$setSubmitting = _ref.setSubmitting,
      setSubmitting = _ref$setSubmitting === void 0 ? null : _ref$setSubmitting;
  return function (_ref2) {
    var _ref2$graphQLErrors = _ref2.graphQLErrors,
        graphQLErrors = _ref2$graphQLErrors === void 0 ? [] : _ref2$graphQLErrors;

    if (navigator.onLine) {
      Logger.error(JSON.stringify(graphQLErrors));
    }

    var message = graphQLErrors.map(function (e) {
      return e.message;
    }).join('\n') || 'Erro de Conexão';
    var title = 'Erro!';

    if (hideLoadingFunction) {
      hideLoadingFunction();
    }

    if (setSubmitting) {
      setSubmitting(false);
    }

    var params = {
      title: title,
      message: message
    };

    if (showSnackbar) {
      params.chip = true;
      params.variant = 'error';
      params.text = "".concat(title, ":").concat(message);
      showSnackbar(params);
    }
  };
};