function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import localforage from 'localforage';
import { InMemoryCache } from 'apollo-cache-inmemory';
import { ApolloLink } from 'apollo-link';
import { setContext } from 'apollo-link-context';
import { HttpLink } from 'apollo-link-http';
import ApolloClient from 'apollo-client';
import axios from 'axios';
import Keycloak from 'keycloak-js';
import { isRunningStandalone } from './offline/offlineUtils';
import { GlobalAfterInitObjects } from './GlobalAfterInitUtils';
import { bootstrapKC } from './keycloak/Keycloak';
export var init =
/*#__PURE__*/
function () {
  var _ref2 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(_ref) {
    var _ref$analyticsCode, analyticsCode, _ref$ravenCode, ravenCode, _ref$reduxOptions, _ref$reduxOptions$app, appState, _ref$apolloOptions, _ref$apolloOptions$of, offlineApolloCacheOptions, uri, _ref$keycloakOptions, keycloakConfig, logoutFunction, renderFunction, keycloak, ReactGA, Raven, store, _ref3, createStore, cache, defaultOptions, _offlineApolloCacheOp, maxSize, _ref4, persistCache, refreshKeycloakToken, authMiddleware, httpLink, client;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _ref$analyticsCode = _ref.analyticsCode, analyticsCode = _ref$analyticsCode === void 0 ? null : _ref$analyticsCode, _ref$ravenCode = _ref.ravenCode, ravenCode = _ref$ravenCode === void 0 ? null : _ref$ravenCode, _ref$reduxOptions = _ref.reduxOptions;
            _ref$reduxOptions = _ref$reduxOptions === void 0 ? {} : _ref$reduxOptions;
            _ref$reduxOptions$app = _ref$reduxOptions.appState, appState = _ref$reduxOptions$app === void 0 ? null : _ref$reduxOptions$app, _ref$apolloOptions = _ref.apolloOptions;
            _ref$apolloOptions = _ref$apolloOptions === void 0 ? {} : _ref$apolloOptions;
            _ref$apolloOptions$of = _ref$apolloOptions.offlineApolloCacheOptions, offlineApolloCacheOptions = _ref$apolloOptions$of === void 0 ? null : _ref$apolloOptions$of, uri = _ref$apolloOptions.uri, _ref$keycloakOptions = _ref.keycloakOptions;
            _ref$keycloakOptions = _ref$keycloakOptions === void 0 ? {} : _ref$keycloakOptions;
            keycloakConfig = _ref$keycloakOptions.keycloakConfig, logoutFunction = _ref$keycloakOptions.logoutFunction, renderFunction = _ref.renderFunction;
            keycloak = Keycloak(keycloakConfig);
            bootstrapKC(keycloak);

            if (!analyticsCode) {
              _context.next = 14;
              break;
            }

            _context.next = 12;
            return import('react-ga');

          case 12:
            ReactGA = _context.sent;
            ReactGA.initialize(analyticsCode);

          case 14:
            if (!ravenCode) {
              _context.next = 19;
              break;
            }

            _context.next = 17;
            return import('raven-js');

          case 17:
            Raven = _context.sent;
            Raven.config(ravenCode).install();

          case 19:
            store = null;

            if (!appState) {
              _context.next = 26;
              break;
            }

            _context.next = 23;
            return import('redux');

          case 23:
            _ref3 = _context.sent;
            createStore = _ref3.createStore;
            store = createStore(appState, window.__REDUX_DEVTOOLS_EXTENSION__ && window.__REDUX_DEVTOOLS_EXTENSION__());

          case 26:
            cache = new InMemoryCache({});
            defaultOptions = {};
            /** *********
             *
             * offline cache config options
             ************ */

            if (!offlineApolloCacheOptions) {
              _context.next = 36;
              break;
            }

            _offlineApolloCacheOp = offlineApolloCacheOptions.maxSize, maxSize = _offlineApolloCacheOp === void 0 ? 1048576 * 20 : _offlineApolloCacheOp;
            _context.next = 32;
            return import('apollo-cache-persist');

          case 32:
            _ref4 = _context.sent;
            persistCache = _ref4.persistCache;
            persistCache({
              cache: cache,
              storage: localforage,
              maxSize: maxSize
            });
            defaultOptions = {
              watchQuery: {
                fetchPolicy: 'cache-and-network'
              },
              query: {
                fetchPolicy: 'cache-and-network',
                notifyOnNetworkStatusChange: true // needed for networkStatus

              }
            };

          case 36:
            refreshKeycloakToken = function refreshKeycloakToken() {
              var minValidity = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 5;
              return new Promise(function (resolve, reject) {
                if (navigator.onLine || !isRunningStandalone()) {
                  keycloak.updateToken(minValidity).success(function () {
                    localforage.setItem('token', keycloak.token);
                    localforage.setItem('refreshToken', keycloak.refreshToken);
                    resolve();
                  }).error(function (error) {
                    return reject(error);
                  });
                } else {
                  resolve();
                }
              });
            };

            authMiddleware = setContext(function (operation, _ref5) {
              var headers = _ref5.headers;
              return refreshKeycloakToken().then(function () {
                return {
                  headers: _objectSpread({}, headers, {
                    authorization: "Bearer ".concat(keycloak.token)
                  })
                };
              }).catch(function () {
                keycloak.login({
                  prompt: 'none'
                });
              });
            });
            axios.interceptors.request.use(function (config) {
              return refreshKeycloakToken().then(function () {
                var newConfig = config;
                newConfig.headers.Authorization = "Bearer ".concat(keycloak.token);
                return Promise.resolve(newConfig);
              }).catch(function () {
                keycloak.login({
                  prompt: 'none'
                });
              });
            });
            httpLink = new HttpLink({
              uri: uri
            });
            client = new ApolloClient({
              link: ApolloLink.from([authMiddleware, httpLink]),
              cache: cache,
              connectToDevTools: true,
              defaultOptions: defaultOptions
            });
            /** ********
             * KEYCLOAK LOGIN
             *********** */

            localforage.ready().then(function () {
              return Promise.all([localforage.getItem('token'), localforage.getItem('refreshToken')]);
            }).then(function (_ref6) {
              var _ref7 = _slicedToArray(_ref6, 2),
                  token = _ref7[0],
                  refreshToken = _ref7[1];

              var initOptions = {
                checkLoginIframe: false
              }; // only set token for standalone pwa

              if (isRunningStandalone()) {
                if (token !== null) {
                  initOptions.token = token;
                }

                if (refreshToken !== null) {
                  initOptions.refreshToken = refreshToken;
                }
              }

              var afterKcInit = function afterKcInit(authenticated) {
                if (!authenticated && navigator.onLine) {
                  var options = isRunningStandalone() ? {
                    scope: 'offline_access'
                  } : undefined;
                  keycloak.login(options);
                } else {
                  localforage.setItem('token', keycloak.token);
                  localforage.setItem('refreshToken', keycloak.refreshToken);
                  keycloak.loadUserProfile().then(function () {
                    renderFunction({
                      keycloak: keycloak,
                      client: client,
                      store: store
                    });
                  });
                }
              };

              keycloak.init(initOptions).success(afterKcInit).error(function () {
                if (!navigator.onLine) {
                  afterKcInit(false);
                } else {
                  logoutFunction(keycloak, client);
                }
              });
            });
            GlobalAfterInitObjects.apolloClient = client;
            GlobalAfterInitObjects.keycloak = keycloak;
            GlobalAfterInitObjects.reduxStore = store;
            return _context.abrupt("return", {
              keycloak: keycloak,
              client: client,
              store: store
            });

          case 46:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function init(_x) {
    return _ref2.apply(this, arguments);
  };
}();